function [images] = SimulateDisplacement(inputImage, topLeftPos, shift, imSize, visSurface, verbose)
% Simulation params
ImageWidth = imSize(2);
ImageHeight = imSize(1);
refImg = (inputImage);

if (topLeftPos(1) <= ImageHeight || topLeftPos(2) <= ImageWidth || topLeftPos(1)+ 2* ImageHeight > size(refImg,1) || topLeftPos(2)+ 2*ImageWidth > size(refImg,2))
    error('topLeftPos coordinate out of the image bounds');
end
images = zeros(ImageHeight, ImageWidth, 2);

if (verbose)
    fprintf('Simulating images');
end
origImg = refImg(topLeftPos(1):topLeftPos(1)+ImageHeight-1,topLeftPos(2):topLeftPos(2)+ImageWidth-1);

shiftedImg = FourierShift(shift(2), shift(1), refImg, []);
YBegin = topLeftPos(1);
YEnd = YBegin + ImageHeight - 1;
XBegin = topLeftPos(2);
XEnd = XBegin + ImageWidth - 1;
image = shiftedImg(YBegin:YEnd,XBegin:XEnd);

images(:,:,1) = origImg * visSurface;
images(:,:,2) = image * visSurface;

end
