function [resImages] = SimulateNoise(images, noisemodel, noise_param_a,noise_param_b, verbose)
switch noisemodel
    case 'pleiades'
        a = noise_param_a;
        b = noise_param_b;
    case 'poisson'
        a = noise_param_a;
        b = noise_param_b;
    case 'speckle'
        v = noise_param_a;
    case 'gaussian'
        sigma = noise_param_a;
end

if (verbose)
    fprintf('Simulating noise');
end
resImages = zeros(size(images));

% Now I will add noise
for i=1:2
    I = images(:,:,i);
    switch(noisemodel)
        case 'pleiades'
            noise = normrnd(0, 1, size(I)).*sqrt(a^2 + b*I);
        case 'gaussian'
            noise = normrnd(0, sigma, size(I));
        case 'poisson'
            J = poissrnd(a^2 + b*I);
            noise = J - I;
        case 'speckle'
            J = imnoise(I, 'speckle', v);
            noise = J - I;
    end
    resImages(:,:,i) = images(:,:,i) + noise;
end
% Check if resulting images are negative
minVal = min(resImages(:));
if (minVal < 0)
    resImages(:,:,:) = resImages(:,:,:) + abs(minVal);
end
end
