function [I_vst] = ApplyVST(I, model, a, b)
    switch model
        case 'tuckey'
            I_vst = sqrt(I + 1) + sqrt(I);
        case 'pleiades'
            % Pleiades VST
            I_vst = real(2/b*sqrt(a^2 + b*I));
        case 'poisson'
            % Anscombe
            I_vst = 2*sqrt(double(I) + (3/8));
        otherwise
            I_vst = I;
    end
end